package org.chris.simpletexo.application;

import java.util.List;
import java.util.HashMap;

import org.chris.simpletexo.model.simpletexo.Book;
import org.chris.simpletexo.model.simpletexo.Page;
import org.chris.simpletexo.model.simpletexo.SimpletexoFactory;
import org.eclipse.emf.ecore.EObject;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class Activator implements BundleActivator {

	static final HashMap<String, Object> EMPTY_MAP = new HashMap<String, Object>(); 
	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		try
		{
			DatabaseResource bookResource = new DatabaseResource();
			DatabaseResource pageResource = new DatabaseResource();

			Book book = SimpletexoFactory.eINSTANCE.createBook();
			book.setTitle("Moby Dick");

			bookResource.getContents().add(book);
			bookResource.save(EMPTY_MAP);
			
			Page page = SimpletexoFactory.eINSTANCE.createPage();
			page.setPageNumber(1);
			
			pageResource.getContents().add(page);
			pageResource.save(EMPTY_MAP);
			
			book.getPages().add(page);
			
			book.eResource().save(EMPTY_MAP);

			DatabaseResource queryResource = new DatabaseResource(true);
			List<EObject> pages = queryResource.query("select p from simpletexo_Page p", EMPTY_MAP, 0, 1);
			if (pages != null && pages.size() > 0)
			{
				for (Object o : pages)
				{
					Page qPage = (Page)o;
					System.out.println(qPage.getBook().getId());
				}
			}
		}
		catch (Exception e)
		{
			System.err.println(e.getLocalizedMessage());
			e.printStackTrace();
		}
	}
	
	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		System.out.println("Goodbye World!!");
	}

}
