package org.chris.simpletexo.application;

import java.util.HashMap;

import javax.persistence.EntityManagerFactory;

import org.chris.simpletexo.model.simpletexo.SimpletexoPackage;
import org.chris.simpletexo.persistence.model.SimpletexoModelPackage;
import org.eclipse.emf.texo.component.ComponentProvider;
import org.eclipse.emf.texo.server.store.EPersistenceService;
import org.eclipse.emf.texo.server.store.EPersistenceTexoResource;
import org.eclipse.emf.texo.store.EObjectStore;
import org.eclipse.persistence.config.PersistenceUnitProperties;
import org.eclipse.persistence.config.TargetDatabase;
import org.eclipse.persistence.jpa.osgi.PersistenceProvider;

public class DatabaseResource extends EPersistenceTexoResource {
	   static boolean needToCreateDatabase = true;
	   static EntityManagerFactory emf = null;
	   static private EPersistenceService persistenceService = null;

	   public DatabaseResource()
	   {
	      super();
	      setEObjectStore(getEPersistenceService(false));
	   }

	   public DatabaseResource(boolean useUniqueObjectStore)
	   {
	      super();
	      setEObjectStore(getEPersistenceService(useUniqueObjectStore));
	   }

	   private EObjectStore getEPersistenceService(boolean useUniqueObjectStore)
	   {
	      if (useUniqueObjectStore)
	      {
	         EPersistenceService service = ComponentProvider.getInstance().newInstance(EPersistenceService.class);
	         service.setEntityManagerFactory(getEntityManagerFactory(needToCreateDatabase));
	         service.setUri("http://texo.eclipse.org");
	         needToCreateDatabase = false;
	         return service;
	      }
	      else if (persistenceService == null)
	      {
	         persistenceService = ComponentProvider.getInstance().newInstance(EPersistenceService.class);
	         persistenceService.setEntityManagerFactory(getEntityManagerFactory(needToCreateDatabase));
	         persistenceService.setUri("http://texo.eclipse.org");
	         needToCreateDatabase = false;
	      }
	      
	      return persistenceService;
	   }

	   private EntityManagerFactory getEntityManagerFactory(boolean create)
	   {
	      if (emf == null)
	      {
	         HashMap<String, Object> properties = new HashMap<String, Object>();
	         properties.put(PersistenceUnitProperties.CLASSLOADER, this.getClass().getClassLoader());

//	         properties.put(PersistenceUnitProperties.SESSION_CUSTOMIZER, "org.chris.texotest.application.UidGenerators");
//	         EmbeddedDataSource eds = new EmbeddedDataSource();
//	         eds.setDatabaseName("C:\\WebAD\\databases\\texotestDB");
	         if (create)
	         {
//	            eds.setCreateDatabase("create");
	            properties.put(PersistenceUnitProperties.DDL_GENERATION, PersistenceUnitProperties.CREATE_ONLY);
	         }

//	         properties.put(PersistenceUnitProperties.NON_JTA_DATASOURCE, eds);
	         properties.put(PersistenceUnitProperties.TARGET_DATABASE, TargetDatabase.Auto);

	         PersistenceProvider pp = new PersistenceProvider();
	         emf = pp.createEntityManagerFactory("BedHead", properties);
	      }

	      return emf;
	   }

	   static
	   {
	      SimpletexoPackage.eINSTANCE.getEFactoryInstance();

	      // initialize the model package
	      // this has to be done other wise the model package is not
	      // registered in the ModelResolver
	      SimpletexoModelPackage.initialize();
	   }
}
