package org.chris.simpletexo.persistence.model;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;

/**
 * A representation of the model object '<em><b>Book</b></em>'. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
@Entity(name = "simpletexo_Book")
public class Book extends Identifiable {

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@OneToMany(cascade = { CascadeType.ALL }, mappedBy = "book")
	@JoinTable()
	private List<Page> pages = new ArrayList<Page>();

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Basic()
	private String title = null;

	/**
	 * Returns the value of '<em><b>pages</b></em>' feature.
	 * 
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the value of '<em><b>pages</b></em>' feature
	 * @generated
	 */
	public List<Page> getPages() {
		return pages;
	}

	/**
	 * Adds to the <em>pages</em> feature.
	 * 
	 * @generated
	 */
	public void addToPages(Page pagesValue) {
		if (!pages.contains(pagesValue)) {
			pages.add(pagesValue);
		}
	}

	/**
	 * Removes from the <em>pages</em> feature.
	 * 
	 * @generated
	 */
	public void removeFromPages(Page pagesValue) {
		if (pages.contains(pagesValue)) {
			pages.remove(pagesValue);
		}
	}

	/**
	 * Clears the <em>pages</em> feature.
	 * 
	 * @generated
	 */
	public void clearPages() {
		while (!pages.isEmpty()) {
			removeFromPages(pages.iterator().next());
		}
	}

	/**
	 * Sets the '{@link Book#getPages() <em>pages</em>}' feature.
	 * 
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param the
	 *            new value of the '{@link Book#getPages() pages}' feature.
	 * @generated
	 */
	public void setPages(List<Page> newPages) {
		pages = newPages;
	}

	/**
	 * Returns the value of '<em><b>title</b></em>' feature.
	 * 
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the value of '<em><b>title</b></em>' feature
	 * @generated
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * Sets the '{@link Book#getTitle() <em>title</em>}' feature.
	 * 
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param the
	 *            new value of the '{@link Book#getTitle() title}' feature.
	 * @generated
	 */
	public void setTitle(String newTitle) {
		title = newTitle;
	}

	/**
	 * A toString method which prints the values of all EAttributes of this
	 * instance. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public String toString() {
		return "Book " + " [title: " + getTitle() + "]";
	}
}
