package org.chris.simpletexo.persistence.model;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.texo.model.ModelFactory;
import org.eclipse.emf.texo.model.ModelPackage;
import org.eclipse.emf.texo.model.ModelResolver;
import org.eclipse.emf.texo.utils.ModelUtils;

/**
 * The <b>Package</b> for the model '<em><b>simpletexo</b></em>'. It contains
 * initialization code and access to the Factory to instantiate types of this
 * package.
 * 
 * <!-- begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class SimpletexoModelPackage extends ModelPackage {

	/**
	 * Is set when the package has been initialized.
	 * 
	 * @generated
	 */
	private static boolean isInitialized = false;

	/**
	 * The package namespace URI. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final String NS_URI = "http://simpletexo/1.0";

	/**
	 * The {@link ModelFactory} for this package. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static final SimpletexoModelFactory MODELFACTORY = new SimpletexoModelFactory();

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final int BOOK_CLASSIFIER_ID = 0;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final int BOOK_PAGES_FEATURE_ID = 1;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final int BOOK_TITLE_FEATURE_ID = 2;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final int IDENTIFIABLE_CLASSIFIER_ID = 2;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final int IDENTIFIABLE_ID_FEATURE_ID = 0;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final int PAGE_CLASSIFIER_ID = 1;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final int PAGE_BOOK_FEATURE_ID = 1;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final int PAGE_PAGENUMBER_FEATURE_ID = 2;

	/**
	 * The static member with the instance of this {@link ModelPackage}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final SimpletexoModelPackage INSTANCE = initialize();

	/**
	 * Initializes this {@link ModelPackage}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public static SimpletexoModelPackage initialize() {

		if (isInitialized) {
			return (SimpletexoModelPackage) ModelResolver.getInstance()
					.getModelPackage(NS_URI);
		}

		final SimpletexoModelPackage modelPackage = new SimpletexoModelPackage();

		ModelResolver.getInstance().registerModelPackage(modelPackage);

		// read the model from the ecore file, the EPackage is registered in the
		// EPackage.Registry
		// see the ModelResolver getEPackageRegistry method
		ModelUtils.readEPackagesFromFile(modelPackage);

		isInitialized = true;

		// force the initialization of the EFactory proxy
		modelPackage.getEPackage();

		// register the relation between a Class and its EClassifier
		ModelResolver.getInstance().registerClassModelMapping(
				Identifiable.class, modelPackage.getIdentifiableEClass(),
				modelPackage);
		ModelResolver.getInstance().registerClassModelMapping(Book.class,
				modelPackage.getBookEClass(), modelPackage);
		ModelResolver.getInstance().registerClassModelMapping(Page.class,
				modelPackage.getPageEClass(), modelPackage);

		// and return ourselves
		return modelPackage;
	}

	/**
	 * Returns the {@link ModelFactory} of this ModelPackage. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the {@link SimpletexoModelFactory} instance.
	 * @generated
	 */
	@Override
	public SimpletexoModelFactory getModelFactory() {
		return MODELFACTORY;
	}

	/**
	 * Returns the nsUri of the {@link EPackage} managed by this Package
	 * instance. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return the nsUri of the EPackage
	 * @generated
	 */
	@Override
	public String getNsURI() {
		return NS_URI;
	}

	/**
	 * Returns the name of the ecore file containing the ecore model of the
	 * {@link EPackage} managed here. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @return the name of the ecore file
	 * @generated
	 */
	@Override
	public String getEcoreFileName() {
		return "simpletexo.ecore";
	}

	/**
	 * Returns the {@link EClass} '<em><b>Book</b></em>'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return an instance of the {@link EClass} '<em><b>Book</b></em>'
	 * @generated
	 */
	public EClass getBookEClass() {
		return (EClass) getEPackage().getEClassifiers().get(BOOK_CLASSIFIER_ID);
	}

	/**
	 * Returns the {@link EStructuralFeature} '<em><b>Book.pages</b></em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return an instance of the {@link EStructuralFeature}: '
	 *         <em><b>Book.pages</b></em>'.
	 * @generated
	 */
	public EReference getBook_Pages() {
		return (EReference) getBookEClass().getEAllStructuralFeatures().get(
				BOOK_PAGES_FEATURE_ID);
	}

	/**
	 * Returns the {@link EStructuralFeature} '<em><b>Book.title</b></em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return an instance of the {@link EStructuralFeature}: '
	 *         <em><b>Book.title</b></em>'.
	 * @generated
	 */
	public EAttribute getBook_Title() {
		return (EAttribute) getBookEClass().getEAllStructuralFeatures().get(
				BOOK_TITLE_FEATURE_ID);
	}

	/**
	 * Returns the {@link EClass} '<em><b>Identifiable</b></em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return an instance of the {@link EClass} '<em><b>Identifiable</b></em>'
	 * @generated
	 */
	public EClass getIdentifiableEClass() {
		return (EClass) getEPackage().getEClassifiers().get(
				IDENTIFIABLE_CLASSIFIER_ID);
	}

	/**
	 * Returns the {@link EStructuralFeature} '<em><b>Identifiable.id</b></em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return an instance of the {@link EStructuralFeature}: '
	 *         <em><b>Identifiable.id</b></em>'.
	 * @generated
	 */
	public EAttribute getIdentifiable_Id() {
		return (EAttribute) getIdentifiableEClass().getEAllStructuralFeatures()
				.get(IDENTIFIABLE_ID_FEATURE_ID);
	}

	/**
	 * Returns the {@link EClass} '<em><b>Page</b></em>'. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @return an instance of the {@link EClass} '<em><b>Page</b></em>'
	 * @generated
	 */
	public EClass getPageEClass() {
		return (EClass) getEPackage().getEClassifiers().get(PAGE_CLASSIFIER_ID);
	}

	/**
	 * Returns the {@link EStructuralFeature} '<em><b>Page.book</b></em>'. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return an instance of the {@link EStructuralFeature}: '
	 *         <em><b>Page.book</b></em>'.
	 * @generated
	 */
	public EReference getPage_Book() {
		return (EReference) getPageEClass().getEAllStructuralFeatures().get(
				PAGE_BOOK_FEATURE_ID);
	}

	/**
	 * Returns the {@link EStructuralFeature} '<em><b>Page.pageNumber</b></em>'.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @return an instance of the {@link EStructuralFeature}: '
	 *         <em><b>Page.pageNumber</b></em>'.
	 * @generated
	 */
	public EAttribute getPage_PageNumber() {
		return (EAttribute) getPageEClass().getEAllStructuralFeatures().get(
				PAGE_PAGENUMBER_FEATURE_ID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param eClassifier
	 *            the {@link EClassifier}
	 * @return the class implementing a specific {@link EClass}.
	 * @generated
	 */
	@Override
	public Class<?> getEClassifierClass(EClassifier eClassifier) {
		switch (eClassifier.getClassifierID()) {
		case IDENTIFIABLE_CLASSIFIER_ID:
			return Identifiable.class;
		case BOOK_CLASSIFIER_ID:
			return Book.class;
		case PAGE_CLASSIFIER_ID:
			return Page.class;
		}
		throw new IllegalArgumentException("The EClassifier '" + eClassifier
				+ "' is not defined in this EPackage");
	}
}
